#include "myGL.h"
char presse, choix;
int anglex,angley,x,y,xold,yold;

/* Prototype des fonctions */
void affichage();
void clavier(unsigned char touche,int x,int y);
void reshape(int x,int y);
void idle();
void mouse(int bouton,int etat,int x,int y);
void mousemotion(int x,int y);

int main(int argc,char **argv)
{
  /* initialisation de glut et creation
     de la fenetre */
  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
  glutInitWindowPosition(100,150);
  glutInitWindowSize(800,800);
  glutCreateWindow("Test");

  /* Initialisation d'OpenGL */
  glClearColor(0.0,0.0,0.0,0.0);
  glColor3f(1.0,1.0,1.0);
  glPointSize(2.0);
  glEnable(GL_DEPTH_TEST);

  /* enregistrement des fonctions de rappel */
  glutDisplayFunc(affichage);
  glutKeyboardFunc(clavier);
  glutReshapeFunc(reshape);
  glutMouseFunc(mouse);
  glutMotionFunc(mousemotion);

  /* Entree dans la boucle principale glut */
  glutMainLoop();
  return 0;
}

void affichage()
{
  int i,j;
  /* effacement de l'image avec la couleur de fond */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  glLoadIdentity();
  glRotatef(-angley,2.0,0.0,0.0);
  glRotatef(-anglex,0.0,1.0,0.0);

	glColor3d(1,1,1);
  switch (choix)
	{
		case '1':
		{
			tetraedre();
			break;
		}
		case '2':
		{
			glPushMatrix();
			glRotatef(-30,1,0,0);
			cone(10);
			glPopMatrix();
			break;
		}
		case '3':
		{
			glPushMatrix();
			glRotatef(-30,1,0,0);
			cylindre(10);
			glPopMatrix();
			break;
		}
		case '4':
		{
			glPushMatrix();
			glRotatef(-45,1,0,0);
			sphere(5,20);
			glPopMatrix();
			break;
		}
		case '5':
		{
			glPushMatrix();
			glRotatef(-15,1,0,0);
			tore(20, 10, 0.1);
			glPopMatrix();
			break;
		}
		case '6':
		{
			Menger(4);
			break;
		}
		case '7':
		{
			glPushMatrix();
			glRotatef(-15,1,0,0);
			glRotatef(45,0,1,0);
			Menger3D(3);
			glPopMatrix();
			break;
		}
		case '8':
		{
			glPushMatrix();
			glTranslated(0,-0.5,0);
			glScaled(1.5,1.5,0);
			Sierpinski(6);
			glPopMatrix();
			break;
		}
		case '9':
		{
			Sierpinski3D(3);
			break;
		}
	}
  /* On echange les buffers */
  glutSwapBuffers();
}

void clavier(unsigned char touche,int x,int y)
{
  switch (touche)
    {
    case 'p': /* affichage du carre plein */
      glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
      glutPostRedisplay();
      break;
    case 'f': /* affichage en mode fil de fer */
      glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
      glutPostRedisplay();
      break;
    case 's' : /* Affichage en mode sommets seuls */
      glPolygonMode(GL_FRONT_AND_BACK,GL_POINT);
      glutPostRedisplay();
      break;
    case 'd':
      glEnable(GL_DEPTH_TEST);
      glutPostRedisplay();
      break;
    case 'D':
      glDisable(GL_DEPTH_TEST);
      glutPostRedisplay();
      break;
    case 'q' : /*la touche 'q' permet de quitter le programme */
      exit(0);
    default:
			choix=touche;
			glutPostRedisplay();
			break;
		}
}

void reshape(int x,int y)
{
  if (x<y)
    glViewport(0,(y-x)/2,x,x);
  else 
    glViewport((x-y)/2,0,y,y);
}

void mouse(int button, int state,int x,int y)
{
  /* si on appuie sur le bouton gauche */
  if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN) 
  {
    presse = 1; /* le booleen presse passe a 1 (vrai) */
    xold = x; /* on sauvegarde la position de la souris */
    yold=y;
  }
  /* si on relache le bouton gauche */
  if (button == GLUT_LEFT_BUTTON && state == GLUT_UP) 
    presse=0; /* le booleen presse passe a 0 (faux) */
}

void mousemotion(int x,int y)
  {
    if (presse) /* si le bouton gauche est presse */
    {
      /* on modifie les angles de rotation de l'objet
	 en fonction de la position actuelle de la souris et de la derniere
	 position sauvegardee */
      anglex=anglex+(x-xold); 
      angley=angley+(y-yold);
      glutPostRedisplay(); /* on demande un rafraichissement de l'affichage */
    }
    
    xold=x; /* sauvegarde des valeurs courante de le position de la souris */
    yold=y;
  }
