#include "myGL.h"

void triangle(){
	glBegin(GL_POLYGON);
	glVertex3f(-0.5, -sin(2*PI/3)/2, 0);
	glVertex3f(0.5, -sin(2*PI/3)/2, 0);
	glVertex3f(0, sin(2*PI/3)/2, 0);
	glEnd();
}

void carree(){
	glBegin(GL_POLYGON);
	glVertex3f(-0.5, -0.5, 0);
	glVertex3f(0.5, -0.5, 0);
	glVertex3f(0.5, 0.5, 0);
	glVertex3f(-0.5, 0.5, 0);
	glEnd();
}

void cercle(int n){
	int i;
	glBegin(GL_POLYGON);
		for(i=0; i<n; i++) 
			glVertex3f(cos(2*PI*i/n)/2, sin(2*PI*i/n)/2, 0);
	glEnd();
}

void tetraedre(){	
	glBegin(GL_POLYGON);
	glVertex3f( 0, sin(2*PI/3)/2, 0);
	glVertex3f(-0.5, -sin(2*PI/3)/2, cos(2*PI/3));
	glVertex3f(0.5, -sin(2*PI/3)/2, cos(2*PI/3));
	glEnd();
	
	glBegin(GL_POLYGON);
	glVertex3f( 0, sin(2*PI/3)/2, 0);
	glVertex3f(-0.5, -sin(2*PI/3)/2, cos(2*PI/3));
	glVertex3f(0, -sin(2*PI/3)/2, -cos(2*PI/3));
	glEnd();
	
	glBegin(GL_POLYGON);
	glVertex3f( 0, sin(2*PI/3)/2, 0);
	glVertex3f(0, -sin(2*PI/3)/2, -cos(2*PI/3));
	glVertex3f(0.5, -sin(2*PI/3)/2, cos(2*PI/3));
	glEnd();
	
	glBegin(GL_POLYGON);
	glVertex3f( 0, -sin(2*PI/3)/2, -cos(2*PI/3));
	glVertex3f(-0.5, -sin(2*PI/3)/2, cos(2*PI/3));
	glVertex3f(0.5, -sin(2*PI/3)/2, cos(2*PI/3));
	glEnd();
}

void cube(){
	glBegin(GL_POLYGON);
	glVertex3f( -0.5, -0.5, -0.5);
	glVertex3f( -0.5, -0.5, 0.5);
	glVertex3f( -0.5, 0.5, 0.5);
	glVertex3f( -0.5, 0.5, -0.5);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex3f( -0.5, -0.5, -0.5);
	glVertex3f( -0.5, -0.5, 0.5);
	glVertex3f( 0.5, -0.5, 0.5);
	glVertex3f( 0.5, -0.5, -0.5);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex3f( 0.5, -0.5, -0.5);
	glVertex3f( 0.5, -0.5, 0.5);
	glVertex3f( 0.5, 0.5, 0.5);
	glVertex3f( 0.5, 0.5, -0.5);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex3f( -0.5, 0.5, -0.5);
	glVertex3f( -0.5, 0.5, 0.5);
	glVertex3f( 0.5, 0.5, 0.5);
	glVertex3f( 0.5, 0.5, -0.5);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex3f( -0.5, -0.5, -0.5);
	glVertex3f( -0.5, 0.5, -0.5);
	glVertex3f( 0.5, 0.5, -0.5);
	glVertex3f( 0.5, -0.5, -0.5);
	glEnd();
	glBegin(GL_POLYGON);
	glVertex3f( -0.5, -0.5, 0.5);
	glVertex3f( -0.5, 0.5, 0.5);
	glVertex3f( 0.5, 0.5, 0.5);
	glVertex3f( 0.5, -0.5, 0.5);
	glEnd();
}

void cone(int n){
	double angle, nangle;
  
	int i;angle=0;
	for(i=1; i<=n; i++){
	glColor3f(1.0, 1.0, 1.0);
	nangle=2.0*PI*i/n;
	
	//Bas
	glBegin(GL_TRIANGLE_STRIP);
	glVertex3f(0.0, -0.5, 0.0);
	glVertex3f(cos(angle)/2, -0.5, sin(angle)/2);
	glVertex3f(cos(nangle)/2, -0.5, sin(nangle)/2);
	glVertex3f(0.0, 0.5, 0.0);
	glEnd();
	angle=nangle;
  }
}

void cylindre(int n){
	double angle, nangle;
  
	int i;angle=0;
	for(i=1; i<=n; i++){
	glBegin(GL_POLYGON);
	nangle=2.0*PI*i/n;
	glVertex3f(cos(angle)/2, -0.5, sin(angle)/2);
	glVertex3f(cos(nangle)/2, -0.5, sin(nangle)/2);
	glVertex3f(cos(nangle)/2, 0.5, sin(nangle)/2);
	glVertex3f(cos(angle)/2, 0.5, sin(angle)/2);
	glEnd();
	//Bas
	glBegin(GL_POLYGON);
	glVertex3f(cos(angle)/2, -0.5, sin(angle)/2);
	glVertex3f(cos(nangle)/2, -0.5, sin(nangle)/2);
	glVertex3f(0.0, -0.5, 0.0);
	glEnd();
	//Haut
	glBegin(GL_POLYGON);
	glVertex3f(cos(angle)/2, 0.5, sin(angle)/2);
	glVertex3f(cos(nangle)/2, 0.5, sin(nangle)/2);
	glVertex3f(0.0, 0.5, 0.0);
	glEnd();
	angle=nangle;
  }
}

void sphere( int p, int m){
	double To, nTo, Phi, nPhi;
	int i, j;
  To=0;
  for(i=1; i<=m; i++){
		Phi=0;
		nTo=2.0*PI*i/m;
		for(j=1; j<p; j++)
		{
			nPhi=(PI/2)*j/p;
			//Demi-Sphere haut
			glBegin(GL_POLYGON);
			glVertex3f(cos(Phi)*cos(To), sin(Phi), cos(Phi)*sin(To));
			glVertex3f(cos(Phi)*cos(nTo), sin(Phi), cos(Phi)*sin(nTo));
			glVertex3f(cos(nPhi)*cos(nTo), sin(nPhi), cos(nPhi)*sin(nTo));
			glVertex3f(cos(nPhi)*cos(To), sin(nPhi), cos(nPhi)*sin(To));
			glEnd();
			//Demi-Sphere bas
			glBegin(GL_POLYGON);
			glVertex3f(cos(Phi)*cos(To), -sin(Phi), cos(Phi)*sin(To));
			glVertex3f(cos(Phi)*cos(nTo), -sin(Phi), cos(Phi)*sin(nTo));
			glVertex3f(cos(nPhi)*cos(nTo), -sin(nPhi), cos(nPhi)*sin(nTo));
			glVertex3f(cos(nPhi)*cos(To), -sin(nPhi), cos(nPhi)*sin(To));
			glEnd();
			Phi=nPhi;
		}
		//Chapeau haut
		glBegin(GL_POLYGON);
		glVertex3f(cos(nPhi)*cos(To), sin(nPhi), cos(nPhi)*sin(To));
		glVertex3f(cos(nPhi)*cos(nTo), sin(nPhi), cos(nPhi)*sin(nTo));
		glVertex3f(0.0, 1.0, 0.0);
		glEnd();
		//Chapeau bas
		glBegin(GL_POLYGON);
		glVertex3f(cos(nPhi)*cos(To), -sin(nPhi), cos(nPhi)*sin(To));
		glVertex3f(cos(nPhi)*cos(nTo), -sin(nPhi), cos(nPhi)*sin(nTo));
		glVertex3f(0.0, -1.0, 0.0);
		glEnd();
		To=nTo;
  }
  glEnd();
}

void tore(int n, int p, double r){
 double To, nTo, Phi, nPhi;
 int i,j;
  To=0;
  for(i=1; i<=n; i++){
	Phi=0;
	nTo=2.0*PI*i/n;
	for(j=1; j<=p; j++)
	{
		nPhi=(2*PI)*j/p;
		glBegin(GL_POLYGON);
		glVertex3f((r*cos(Phi)+0.5)*cos(To), r*sin(Phi), (r*cos(Phi)+0.5)*sin(To));
		glVertex3f((r*cos(nPhi)+0.5)*cos(To), r*sin(nPhi), (r*cos(nPhi)+0.5)*sin(To));
		glVertex3f((r*cos(nPhi)+0.5)*cos(nTo), r*sin(nPhi), (r*cos(nPhi)+0.5)*sin(nTo));
		glVertex3f((r*cos(Phi)+0.5)*cos(nTo), r*sin(Phi), (r*cos(Phi)+0.5)*sin(nTo));
		glEnd();
		Phi=nPhi;
	}
	To=nTo;
  }
}

void Sierpinski(int n){
	glPushMatrix();
	glScaled(0.5, 0.5, 1);
	if(n==1){
		glTranslated(0.5, 0, 0);
		triangle();
		glTranslated(-1, 0, 0);
		triangle();
		glTranslated(0.5, sqrt(3)/2, 0);
		triangle();
	}
	else {
		glTranslated(0.5, 0, 0);
		Sierpinski(n-1);
		glTranslated(-1, 0, 0);
		Sierpinski(n-1);
		glTranslated(0.5, sqrt(3)/2, 0);
		Sierpinski(n-1);
	}
  glPopMatrix();
}

void Sierpinski3D(int n){
	glPushMatrix();
	glScaled(0.5, 0.5, 0.5);
	if(n==1){
		glTranslated(0.5, -0.5, 0);
		glColor3d(1,1,1); //Tetraedre bas droit en blanc
		tetraedre();
		glTranslated(-0.5, 0, 1);
		glColor3d(1,0,0); //Tetraedre bas centre en rouge
		tetraedre();
		glTranslated(-0.5, 0, -1);
		glColor3d(0,1,0); //Tetraedre bas gauche en vert
		tetraedre();
		glTranslated(0.5, sqrt(3)/2, 0.5);
		glColor3d(0,0,1); //Tetraedre haut en bleu
		tetraedre();
	}
	else {
		glTranslated(0.5, -0.5, 0);
		Sierpinski3D(n-1);
		glTranslated(-0.5, 0, 1);
		Sierpinski3D(n-1);
		glTranslated(-0.5, 0, -1);
		Sierpinski3D(n-1);
		glTranslated(0.5, sqrt(3)/2, 0.5);
		Sierpinski3D(n-1);
	}
  glPopMatrix();
}

void Menger(int n){
	glPushMatrix();
	double i, j;
	glScaled((double)1/3, (double)1/3, 1);
	if(n==1){
		for(i=-1; i<=1; i++)
			for(j=-1; j<=1; j++)
				if (!(i==0 && j==0)){
					glPushMatrix();
					glTranslated(i, j, 0);
					carree();
					glPopMatrix();
				}
	}
	else {
		for(i=-1; i<=1; i++)
			for(j=-1; j<=1; j++)
				if (i!=0 || j!=0){
					glPushMatrix();
					glTranslated(i, j, 0);
					Menger(n-1);
					glPopMatrix();
				}
	}
  glPopMatrix();
}

void Menger3D(int n){
	glPushMatrix();
	int x, y, z;
	glScaled((double)1/3, (double)1/3, (double)1/3);
	if(n==1){
		for(x=-1; x<=1; x++)
			for(y=-1; y<=1; y++)
				for(z=-1;z<=1; z++)
				if (!(x==0 && y==0) && !(x==0 && z==0) && !(y==0 && z==0)){
					glPushMatrix();
					glColor3d((1-x)/2, (1-y)/2, (1-z)/2);
					glTranslated(x, y, z);
					cube();
					glPopMatrix();
				}
	}
	else {
		for(x=-1; x<=1; x++)
			for(y=-1; y<=1; y++)
				for(z=-1;z<=1; z++)
					if (!(x==0 && y==0) && !(x==0 && z==0) && !(y==0 && z==0)){
						glPushMatrix();
						glTranslated(x, y, z);
						Menger3D(n-1);
						glPopMatrix();
					}
	}
  glPopMatrix();
}